commit:     e1448b86b8d3d0123457c6177d73f8a8e321a2ab
Author:     Lukas Schmelting <lschmelting <AT> posteo <DOT> com>
AuthorDate: Mon May 12 19:56:53 2025 +0000
Commit:     Sam James <sam <AT> gentoo <DOT> org>
CommitDate: Thu May 22 22:20:36 2025 +0000
URL:        https://gitweb.gentoo.org/repo/gentoo.git/commit/?id=e1448b86

gui-libs/gtk: Version bump to 4.18.5

Signed-off-by: Lukas Schmelting <lschmelting <AT> posteo.com>
Part-of: https://github.com/gentoo/gentoo/pull/42128
Signed-off-by: Sam James <sam <AT> gentoo.org>

 gui-libs/gtk/Manifest                              |   1 +
 ...son-macro-to-hide-GDK_WINDOWING_ge_4.18.5.patch |  93 +++++++
 gui-libs/gtk/gtk-4.18.5.ebuild                     | 273 +++++++++++++++++++++
 3 files changed, 367 insertions(+)

diff --git a/gui-libs/gtk/Manifest b/gui-libs/gtk/Manifest
index 21ef0e9506eb..51e523bda8da 100644
--- a/gui-libs/gtk/Manifest
+++ b/gui-libs/gtk/Manifest
@@ -1,3 +1,4 @@
 DIST gtk-4.14.4.tar.xz 18306548 BLAKE2B 
352831cb6373488593831e0d3489d425ca19b2b6c5541e269e251bb4f0455b435d73d24befef441fe09537838446eb773f33cbca746a9aeeed2204c413535ac0
 SHA512 
33a983f4ebac9088eaf9d3794a171d1619632bbcb27d9f46d894305dc15f83615a18443598b3c62a553b9596438b58226560ba17c41e539c76c3ee8a2b62c651
 DIST gtk-4.16.12.tar.xz 14620652 BLAKE2B 
298c6f41e6100f9ebf7b51bf93c55102c82b4eac53bb834744ae545b2ee2ac83c7bd271e0c64ff03031d61042259695528ea36e8a1efac704bbe73dac77e7f7f
 SHA512 
ca6deabe0447524ef021ddf367e28a40f7571d1efcd11890dc54e20d944a4c6173c6c98da6a5902ddd8b393369f9f5e843deda667b7333916ac103daf2e283d1
 DIST gtk-4.16.13.tar.xz 14625864 BLAKE2B 
86c0bcf8c6f46db600fd000265b11e8d2f20d7dd90a9f09b2907cbe112a6d1d3a6cadef39436aa13e0917ee1f39e8c31b948862e222edcff4d412e7ac69b485a
 SHA512 
6a220b716b0fdaa9c59d28e4923388f22a84bc4de5693555e5e78af7bcf2835768d6c92dea18dbc3905681d5936761dd402c6e51016ea4c4f23ab5512894f1d8
+DIST gtk-4.18.5.tar.xz 17706144 BLAKE2B 
1184eb9c2da53b917601bda0269b8d0402a829de9a72e0d560342a45f4d7ba7f5d39e7b17b06368650df3d8d369a1e2cca5c490425d7a4171ea67ebce6d6d994
 SHA512 
4a09188fdbeb532d8c2064199126eaf60d806118bb637d5182121f3d80d374acdf343568c3423effb9574c364279ded7d7cbd4e0331dc1fb647970f60c98bff0

diff --git 
a/gui-libs/gtk/files/0001-gdk-add-a-poison-macro-to-hide-GDK_WINDOWING_ge_4.18.5.patch
 
b/gui-libs/gtk/files/0001-gdk-add-a-poison-macro-to-hide-GDK_WINDOWING_ge_4.18.5.patch
new file mode 100644
index 000000000000..18b6dc425b2f
--- /dev/null
+++ 
b/gui-libs/gtk/files/0001-gdk-add-a-poison-macro-to-hide-GDK_WINDOWING_ge_4.18.5.patch
@@ -0,0 +1,93 @@
+From e00bc31abbc489f1787cd5b2d5c441dbb82ed03a Mon Sep 17 00:00:00 2001
+From: Eli Schwartz <[email protected]>
+Date: Wed, 19 Jun 2024 21:28:31 -0400
+Subject: [PATCH] gdk: add a "poison" macro to hide GDK_WINDOWING_*
+
+Many packages perform automagic dependencies on gdk's backend
+implementations by checking if the macro is defined and then using the
+code it unlocks, rather than having a buildsystem option such as
+-Dwayland=true.
+
+It's unfeasible to patch every such package's source code to add
+configure options and respect them. Instead add a truly filthy hack and
+permit gtk itself to selectively show or hide the windowing system in
+use.
+
+By default, we assume this macro is never defined. It should only ever
+be defined inside an ebuild, as such:
+
+```
+use wayland || append-cflags -DGENTOO_GTK_HIDE_WAYLAND
+use X || append-cflags -DGENTOO_GTK_HIDE_X11
+```
+
+When seen, this will prevent code using "#ifdef GDK_WINDOWING_*" from
+seeing the define, so the automagic dependency won't be picked up. It
+will also cause any attempt to #include the backend-specific headers to
+bug out.
+
+Bug: https://bugs.gentoo.org/624960
+Signed-off-by: Eli Schwartz <[email protected]>
+Signed-off-by: Lukas Schmelting <[email protected]>
+---
+ gdk/gdkconfig.h.meson    | 7 +++++++
+ gdk/wayland/gdkwayland.h | 4 ++++
+ gdk/x11/gdkx.h           | 4 ++++
+ 3 files changed, 15 insertions(+)
+
+diff --git a/gdk/gdkconfig.h.meson b/gdk/gdkconfig.h.meson
+index 17276e0..03cf61c 100644
+--- a/gdk/gdkconfig.h.meson
++++ b/gdk/gdkconfig.h.meson
+@@ -10,11 +10,18 @@
+ G_BEGIN_DECLS
+ 
+ 
++#ifndef GENTOO_GTK_HIDE_X11
+ #mesondefine GDK_WINDOWING_X11
++#endif
++
+ #mesondefine GDK_WINDOWING_ANDROID
+ #mesondefine GDK_WINDOWING_BROADWAY
+ #mesondefine GDK_WINDOWING_MACOS
++
++#ifndef GENTOO_GTK_HIDE_WAYLAND
+ #mesondefine GDK_WINDOWING_WAYLAND
++#endif
++
+ #mesondefine GDK_WINDOWING_WIN32
+ 
+ #mesondefine GDK_RENDERING_CAIRO
+diff --git a/gdk/wayland/gdkwayland.h b/gdk/wayland/gdkwayland.h
+index 8464459..5d84619 100644
+--- a/gdk/wayland/gdkwayland.h
++++ b/gdk/wayland/gdkwayland.h
+@@ -24,6 +24,10 @@
+ 
+ #pragma once
+ 
++#ifdef GENTOO_GTK_HIDE_WAYLAND
++  #error "A Gentoo ebuild has hidden wayland and it cannot be used in this 
compilation unit. Please file a bug if you see this error."
++#endif
++
+ #include <gdk/gdk.h>
+ 
+ #define __GDKWAYLAND_H_INSIDE__
+diff --git a/gdk/x11/gdkx.h b/gdk/x11/gdkx.h
+index 6bef6b6..d4f8b94 100644
+--- a/gdk/x11/gdkx.h
++++ b/gdk/x11/gdkx.h
+@@ -24,6 +24,10 @@
+ 
+ #pragma once
+ 
++#ifdef GENTOO_GTK_HIDE_X11
++  #error "A Gentoo ebuild has hidden x11 and it cannot be used in this 
compilation unit. Please file a bug if you see this error."
++#endif
++
+ #include <gdk/gdk.h>
+ 
+ #include <X11/Xlib.h>
+-- 
+2.49.0
+

diff --git a/gui-libs/gtk/gtk-4.18.5.ebuild b/gui-libs/gtk/gtk-4.18.5.ebuild
new file mode 100644
index 000000000000..76bb806b98ef
--- /dev/null
+++ b/gui-libs/gtk/gtk-4.18.5.ebuild
@@ -0,0 +1,273 @@
+# Copyright 2023-2025 Gentoo Authors
+# Distributed under the terms of the GNU General Public License v2
+
+EAPI=8
+PYTHON_COMPAT=( python3_{11..13} )
+inherit gnome.org gnome2-utils meson optfeature python-any-r1 toolchain-funcs 
virtualx xdg
+
+DESCRIPTION="GTK is a multi-platform toolkit for creating graphical user 
interfaces"
+HOMEPAGE="https://www.gtk.org/ https://gitlab.gnome.org/GNOME/gtk/";
+
+LICENSE="LGPL-2+"
+SLOT="4"
+REQUIRED_USE="
+       || ( aqua wayland X )
+       test? ( introspection )
+"
+KEYWORDS="~alpha ~amd64 ~arm ~arm64 ~hppa ~loong ~ppc ~ppc64 ~riscv ~sparc 
~x86"
+IUSE="accessibility aqua broadway cloudproviders colord cups examples 
gstreamer +introspection sysprof test vulkan wayland +X cpu_flags_x86_f16c"
+
+# TODO: Optional gst build dep on >=gst-plugins-base-1.23.1, so depend on it 
once we can
+COMMON_DEPEND="
+       >=dev-libs/glib-2.76.0:2
+       >=x11-libs/cairo-1.18.2[aqua?,glib,svg(+),X?]
+       >=x11-libs/pango-1.56.0[introspection?]
+       >=dev-libs/fribidi-1.0.6
+       >=media-libs/harfbuzz-8.4.0:=
+       >=x11-libs/gdk-pixbuf-2.30:2[introspection?]
+       media-libs/libpng:=
+       media-libs/tiff:=
+       media-libs/libjpeg-turbo:=
+       >=media-libs/libepoxy-1.4[egl(+),X(+)?]
+       >=media-libs/graphene-1.10.0[introspection?]
+       app-text/iso-codes
+       x11-misc/shared-mime-info
+
+       cloudproviders? ( net-libs/libcloudproviders )
+       colord? ( >=x11-misc/colord-0.1.9:0= )
+       cups? ( >=net-print/cups-2.0 )
+       examples? ( gnome-base/librsvg:2 )
+       gstreamer? (
+               >=media-libs/gstreamer-1.24.0:1.0
+               >=media-libs/gst-plugins-bad-1.24.0:1.0
+               || (
+                       >=media-libs/gst-plugins-base-1.24.0:1.0[gles2]
+                       >=media-libs/gst-plugins-base-1.24.0:1.0[opengl]
+               )
+       )
+       introspection? ( >=dev-libs/gobject-introspection-1.76:= )
+       vulkan? ( >=media-libs/vulkan-loader-1.3:=[wayland?,X?] )
+       wayland? (
+               >=dev-libs/wayland-1.23.0
+               >=dev-libs/wayland-protocols-1.41
+               media-libs/mesa[wayland]
+               >=x11-libs/libxkbcommon-0.2
+       )
+       X? (
+               media-libs/fontconfig
+               media-libs/mesa[X(+)]
+               x11-libs/libX11
+               >=x11-libs/libXi-1.8
+               x11-libs/libXext
+               >=x11-libs/libXrandr-1.5
+               x11-libs/libXcursor
+               x11-libs/libXfixes
+               x11-libs/libXdamage
+               x11-libs/libXinerama
+       )
+"
+DEPEND="${COMMON_DEPEND}
+       kernel_linux? (
+               x11-libs/libdrm
+               sys-kernel/linux-headers
+       )
+       sysprof? ( >=dev-util/sysprof-capture-3.40.1:4 )
+       X? ( x11-base/xorg-proto )
+"
+RDEPEND="${COMMON_DEPEND}
+       >=dev-util/gtk-update-icon-cache-3
+"
+# librsvg for svg icons (PDEPEND to avoid circular dep on wd40 profiles with 
librsvg[tools]), bug #547710
+PDEPEND="
+       gnome-base/librsvg:2
+       >=x11-themes/adwaita-icon-theme-3.14
+"
+BDEPEND="
+       >=dev-build/meson-1.2.0
+       dev-libs/gobject-introspection-common
+       introspection? (
+               ${PYTHON_DEPS}
+               $(python_gen_any_dep '
+                       dev-python/pygobject:3[${PYTHON_USEDEP}]
+               ')
+       )
+       dev-python/docutils
+       >=dev-libs/glib-2.80
+       >=dev-util/gdbus-codegen-2.48
+       dev-util/glib-utils
+       >=sys-devel/gettext-0.19.7
+       virtual/pkgconfig
+       vulkan? ( media-libs/shaderc )
+       wayland? (
+               dev-util/wayland-scanner
+       )
+       test? (
+               dev-libs/glib:2
+               media-fonts/cantarell
+               wayland? ( dev-libs/weston[headless] )
+       )
+"
+
+PATCHES=(
+       # Gentoo-specific patch to add a "poison" macro support, allowing other 
ebuilds
+       # with USE="-wayland -X" to trick gtk into claiming that it wasn't 
built with
+       # such support.
+       # https://bugs.gentoo.org/624960
+       
"${FILESDIR}"/0001-gdk-add-a-poison-macro-to-hide-GDK_WINDOWING_ge_4.18.5.patch
+)
+
+python_check_deps() {
+       python_has_version "dev-python/pygobject:3[${PYTHON_USEDEP}]" || return
+}
+
+pkg_setup() {
+       use introspection && python-any-r1_pkg_setup
+}
+
+src_prepare() {
+       default
+       xdg_environment_reset
+
+       # Nothing should use gtk4-update-icon-cache and an unversioned one is 
shipped by dev-util/gtk-update-icon-cache
+       sed -i \
+               -e '/gtk4-update-icon-cache/d' \
+               docs/reference/gtk/meson.build \
+               tools/meson.build \
+               || die
+
+       # The border-image-excess-size.ui test is known to fail on big-endian 
platforms
+       # See https://gitlab.gnome.org/GNOME/gtk/-/issues/5904
+       if [[ $(tc-endian) == big ]]; then
+               sed -i \
+                       -e "/border-image-excess-size.ui/d" \
+                       -e "/^xfails =/a 'border-image-excess-size.ui'," \
+                       testsuite/reftests/meson.build || die
+       fi
+}
+
+src_configure() {
+       local emesonargs=(
+               # GDK backends
+               $(meson_use X x11-backend)
+               $(meson_use wayland wayland-backend)
+               $(meson_use broadway broadway-backend)
+               -Dwin32-backend=false
+               -Dandroid-backend=false
+               $(meson_use aqua macos-backend)
+
+               # Media backends
+               $(meson_feature gstreamer media-gstreamer)
+
+               # Print backends
+               -Dprint-cpdb=disabled
+               $(meson_feature cups print-cups)
+
+               # Optional dependencies
+               $(meson_feature vulkan)
+               $(meson_feature cloudproviders)
+               $(meson_feature sysprof)
+               -Dtracker=disabled  # tracker3 is not packaged in Gentoo yet
+               $(meson_feature colord)
+               # Expected to fail with GCC < 11
+               # See https://gcc.gnu.org/bugzilla/show_bug.cgi?id=71993
+               $(meson_feature cpu_flags_x86_f16c f16c)
+
+               # Introspection
+               $(meson_feature introspection)
+
+               # Documentation
+               -Ddocumentation=false # we ship pregenerated API docs from 
tarball
+               -Dscreenshots=false
+               -Dman-pages=true
+
+               # Demos, examples, and tests
+               -Dprofile=default
+               $(meson_use examples build-demos)
+               $(meson_use test build-testsuite)
+               $(meson_use examples build-examples)
+               -Dbuild-tests=false
+       )
+       meson_src_configure
+}
+
+src_test() {
+       "${BROOT}${GLIB_COMPILE_SCHEMAS}" --allow-any-name "${S}/gtk" || die
+
+       addwrite /dev/dri
+
+       # Note that skipping gsk-compare entirely means we do run *far*
+       # fewer tests, but a reliable testsuite for us is more important
+       # than absolute-maximum coverage if we can't trust the results and
+       # dismiss any failures as "probably font related" and so on.
+       if use X; then
+               einfo "Running tests under X"
+               GSETTINGS_SCHEMA_DIR="${S}/gtk" virtx meson_src_test 
--timeout-multiplier=130 \
+                       --setup=x11 \
+                       --no-suite=failing \
+                       --no-suite=x11_failing \
+                       --no-suite=flaky \
+                       --no-suite=headless \
+                       --no-suite=gsk-compare \
+                       --no-suite=gsk-compare-broadway \
+                       --no-suite=needs-udmabuf \
+                       --no-suite=pango
+       fi
+
+       if use wayland; then
+               einfo "Running tests under Weston"
+
+               export XDG_RUNTIME_DIR="$(mktemp -p $(pwd) -d 
xdg-runtime-XXXXXX)"
+
+               weston --backend=headless-backend.so --socket=wayland-5 
--idle-time=0 &
+               compositor=$!
+               export WAYLAND_DISPLAY=wayland-5
+
+               GSETTINGS_SCHEMA_DIR="${S}/gtk" meson_src_test 
--timeout-multiplier=130 \
+                       --setup=wayland \
+                       --no-suite=failing \
+                       --no-suite=wayland_failing \
+                       --no-suite=flaky \
+                       --no-suite=headless \
+                       --no-suite=gsk-compare \
+                       --no-suite=gsk-compare-broadway \
+                       --no-suite=needs-udmabuf
+
+               exit_code=$?
+               kill ${compositor}
+       fi
+}
+
+src_install() {
+       meson_src_install
+
+       # TODO: Seems that HTML docs are no longer in the tarball after
+       # upstream switched to CI-generated releases? bug #947514
+       #insinto /usr/share/gtk-doc/html
+       # This will install API docs specific to X11 and wayland regardless of 
USE flags, but this is intentional
+       #doins -r 
"${S}"/docs/reference/{gtk/gtk4,gsk/gsk4,gdk/gdk4{,-wayland,-x11}}
+}
+
+pkg_preinst() {
+       xdg_pkg_preinst
+       gnome2_schemas_savelist
+}
+
+pkg_postinst() {
+       xdg_pkg_postinst
+       gnome2_schemas_update
+
+       if ! has_version "app-text/evince"; then
+               elog "Please install app-text/evince for print preview 
functionality."
+               elog "Alternatively, check \"gtk-print-preview-command\" 
documentation and"
+               elog "add it to your settings.ini file."
+       fi
+
+       if use examples ; then
+               optfeature "syntax highlighting in gtk4-demo" app-text/highlight
+       fi
+}
+
+pkg_postrm() {
+       xdg_pkg_postrm
+       gnome2_schemas_update
+}

Reply via email to